(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec"));
	else if(typeof define === 'function' && define.amd)
		define(["@musical-patterns/id", "@musical-patterns/material", "@musical-patterns/utilities", "@musical-patterns/spec"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec")) : factory(root["@musical-patterns/id"], root["@musical-patterns/material"], root["@musical-patterns/utilities"], root["@musical-patterns/spec"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__824__, __WEBPACK_EXTERNAL_MODULE__735__, __WEBPACK_EXTERNAL_MODULE__999__, __WEBPACK_EXTERNAL_MODULE__918__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 377:
/***/ ((module) => {

// Module
var code = "<div class=\"row\"> <div class=\"middle\"> <p> <i> music in the shape of a houndstooth, using the square root of 2 extensively </i> </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> I wrote this piece by translating the houndstooth pattern into music in a couple different ways. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> All notes in the Houndstoothtopia Theme have a duration of either 1 beat or √2 beats. √2 ≈ 1.414, smack dab in-between 1.5 and 1.333, so it will feel neither quite like a dotted beat (3:2), nor quite like a beat tied to a triplet of itself (4:3). It's close to 7:5, though, if that helps you feel it at all. </p> </div> <div class=\"right\"> <p> This is analagous to steps of the traditional Western pitch system. If a dotted beat is like the perfect fifth, and a beat tied to a triplet of itself is like the perfect fourth, then the √2 beat is the tritone. </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Used in a single unified rhythm, this √2 beat may simply add a bit of shuffle to your step. However, the Houndstoothtopia Theme boasts two different underlying rhythms, so its voices quickly sort themselves into two separate rhythmic groups. In this type of situation, playing loosely will not cut it; the accuracy of the interval must be respected or the piece would degenerate into sludge. </p> <p> Because √2 is irrational, the only way for voices to realign after such dis-alignment would be to eventually have moved by the same count of √2's. Fortunately, the Houndstoothtopia Theme's two different underlying rhythms are designed to have the same count of √2's, so they do realign after each segment of the piece. And in the middle of each segment we get to enjoy some wacky staggering, creating new meta-intervals such as √2 - 1. </p> <p> And now for a discussion of the two different underlying rhythms of the piece. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <h3> Supertile Rhythm </h3> <p> Here is the supertile rhythm: </p> <p> <b> short, long, <br> short, short, long, <br> short, short, long, long, <br> short, long, long, </b> </p> <p> where each short note has a duration of 1 and each long note has a duration of √2. </p> <p> In order to answer the question: \"Why is it called the Supertile Rhythm?\" we must first understand what the supertile is. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> The houndstooth pattern can be thought of as a repetition of four basic square tiles: a solid black tile, a solid white tile, and two different tiles which are both diagonally striped black and white but one of them begins with a black stripe and the other begins with a white stripe. </p> </div> <div class=\"right\"> <p>(diagram showing these)</p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> A supertile is a group of connected tiles which function together like a tile. In the case of the houndstooth pattern, the simplest supertile is a 2x2 square containing one each of the four aforementioned basic tiles. </p> </div> <div class=\"right\"> <p>(supertile diagram, which is just the highlighted from the previous blown up)</p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> And now, how to get from this supertile to the above rhythm? </p> <p> Think of each tile as a series of diagonal stripes, even if it is solid. In the case of the white tile, for example, you could think of it as four white stripes - you can't tell that they're stripes because they're all the same color. (For these purposes, we ignore the fact that the first and last stripes, being adjacent to the corners of the tile, are clipped so that one side is reduced to a point causing them to be triangles, lacking parallel lines and thus not quite feeling like stripes.) </p> <p> For each tile of the supertile, find the minimum number of stripe colors necessary to describe the tile in terms of the repeating pattern starting from the top left. For solid tiles this would be 1. For striped tiles it is 2. </p> </div> <div class=\"right\"> <p>(image)</p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Take the maximum of those minima, and use that as your standard. In other words, you are now describing your supertile like this: </p> </div> <div class=\"right\"> <p> [ [ white, white ], [ white, black ] ], [ [ black, white ], [ black, black ] ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Now create a cycle by choosing elements counter-clockwise around that nested array, like this: </p> </div> <div class=\"right\"> <p> [ [ white, white ], [ black, white ], [ black, black ], [ white, black ], ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Now substitute in 1 for white, 2 for black. </p> </div> <div class=\"right\"> <p> [ [ 1, 1 ], [ 2, 1 ], [ 2, 2 ], [ 1, 2 ], ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Now, map [ short, long ] over the sequence, meaning that if short matches up with a 1, use 2 short beats: </p> </div> <div class=\"right\"> <p> [ [ [ short ], [ long ] ], [ [ short, short ], [ long ] ], [ [ short, short ], [ long, long ] ], [ [ short ], [ long, long ] ], ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> And that's it! Once we flatten completely / clean up all the nested array structure, we have our supertile rhythm: </p> </div> <div class=\"right\"> <p> short, long, short, short, long, short, short, long, long, short, long, long, </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> The end result I hear more readily as beats in clusters of 2, 3, 3, 1, 2, and 1. But under the hood this is how it works. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <h3> Perimeter Rhythm </h3> <p> Here is the perimeter rhythm: </p> <p> <b> short, long, short, short, long, short, double-long, <br> short, long, short, short, long, short, double-long, </b> </p> <p> where a short beat has duration 1, a long has duration √2, and a double-long has duration 2√2. </p> <p> (Oh yeah, I stretched the truth a bit earlier; there are three durations in the Houndstoothtopia Theme: 1,√2, and 2√2). </p> <p> This is arrived at by starting on one vertex of the houndstooth shape, tracing its perimeter edge by edge, and recording their lengths. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> Interestingly, the perimeter rhythm begins similarly to the supertile rhythm, despite being generated in a very different way. </p> </div> <div class=\"right\"> <p> (show them overlaid) </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> The perimeter rhythm also has harmonic content, however, and this is where it gets a bit complicated. For each note in the perimeter rhythm, attribute to it a pitch scaled by the height of the vertex. </p> <p> You can rotate the houndstooth perimeter, and while the edge lengths won't change and thus the rhythm won't change, the heights of the vertices will. The Houndstoothtopia them uses four different rotations of the houndsooth. </p> </div> <div class=\"right\"> <p> (show them) </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <h3> Song structure </h3> <p> The perimeter rhythm is longer than the supertile rhythm, in a ratio of 4:3. </p> <p> Okay, so again, I lied a bit earlier. The supertile rhythm and the perimeter rhythm do not have the exact same number of √2 beats in them. They just have a simple ratio of them to each other. This way, after repeating 3 perimeter rhythms and 4 supertile rhythms, they've realigned. </p> <p> Weirdly, though, the perimeter rhythm does not hypermetrically organize in groups of 3. It goes by groups of 4. This way, the supertile rhythm keeps sliding into different alignments with the hypermetrical structure of the perimeter rhythm. </p> <p> What is that hypermetrical structure? First, recognize four perimeter rhythm voices. Every one plays the perimeter rhythm, but each one plays a different rotation of it, thus contributing different pitches to the chords they make together. </p> <p> Repeat the perimeter rhythm four times for each of the four rotations of the perimeter rhythm: - first repetition: no voice sounds. - second repetition: just the voice for the current rotation sounds. - third repetition: all the voices sound. - fourth repetition: all the voices except the one for the current rotation sound. </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> A parallelism exists between this hypermetrical structure for the perimeter rhythm voices and the supertile rhythm. Imagine if starting from this point: </p> </div> <div class=\"right\"> <p> [ [ white, white ], [ black, white ], [ black, black ], [ white, black ], ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> You instead substituted in \"sound\" and \"no sound\": </p> </div> <div class=\"right\"> <p> [ [ no sound, no sound ], [ sound, no sound ], [ sound, sound ], [ no sound, sound ], ] </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <p> And then instead of [ short, long ] you mapped over that [ current, others ]: </p> </div> <div class=\"right\"> <p> [ [ current - no sound, others - no sound ], [ current - sound, others - no sound ], [ current - sound, others - sound ], [ current - no sound, others - sound ], ] </p> </div> </div> ";
// Exports
module.exports = code;

/***/ }),

/***/ 824:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__824__;

/***/ }),

/***/ 735:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__735__;

/***/ }),

/***/ 918:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__918__;

/***/ }),

/***/ 999:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__999__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "pattern": () => (/* reexport */ pattern),
  "patterns": () => (/* reexport */ patterns)
});

// EXTERNAL MODULE: external "@musical-patterns/id"
var id_ = __webpack_require__(824);
// EXTERNAL MODULE: external "@musical-patterns/material"
var material_ = __webpack_require__(735);
// EXTERNAL MODULE: external "@musical-patterns/utilities"
var utilities_ = __webpack_require__(999);
;// CONCATENATED MODULE: ./src/material/constants.ts
// tslint:disable no-magic-numbers

var HOUNDSTOOTHTOPIA_THEME_ENVELOPE_SCALAR = utilities_.as.Scalar(utilities_.use.Cardinal(utilities_.SQUARE_ROOT_OF_TWO, utilities_.as.Cardinal((0,utilities_.negative)(1))));
var HIGHER_SUPERTILE_PITCH = utilities_.as.Scalar(utilities_.use.Scalar(utilities_.SQUARE_ROOT_OF_TWO, utilities_.FIVE_HALVES));
var LOWER_SUPERTILE_PITCH = utilities_.as.Scalar(1);
var TOP_RIGHT_GRAIN_SEQUENCE_INDEX_TO_VARY = utilities_.as.Ordinal(0);
var TOP_GRAIN_SEQUENCE_INDEX_TO_VARY = utilities_.as.Ordinal(1);
var TOP_LEFT_GRAIN_SEQUENCE_INDEX_TO_VARY = utilities_.as.Ordinal(2);
var LEFT_GRAIN_SEQUENCE_INDEX_TO_VARY = utilities_.as.Ordinal(3);
var HOUNDSTOOTHTOPIA_THEME_X_POSITION_SCALE_INDEX = utilities_.as.Ordinal(0);


;// CONCATENATED MODULE: ./src/material/features.ts
var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};



var computeNote = function (_a) {
    var _b = __read(_a), pitch = _b[0], value = _b[1], position = _b.slice(2);
    return ({
        envelope: {
            scalar: HOUNDSTOOTHTOPIA_THEME_ENVELOPE_SCALAR,
        },
        intensity: {
            scalar: pitch === utilities_.as.number(material_.STANDARD_PITCH_INDEX_INDICATING_REST) ?
                material_.SILENT :
                undefined,
        },
        pitch: {
            scalar: utilities_.as.Scalar(pitch),
        },
        position: (0,utilities_.map)(position, function (positionElement, index) { return ({
            scalar: utilities_.as.Scalar(positionElement),
            scaleIndex: utilities_.use.Transition(HOUNDSTOOTHTOPIA_THEME_X_POSITION_SCALE_INDEX, utilities_.as.Transition(utilities_.as.number(index))),
        }); }),
        value: {
            index: utilities_.as.Ordinal(value),
        },
    });
};
var computeSupertileNote = function (contourElement) {
    var _a = __read(contourElement, 1), pitch = _a[0];
    var silentScalar = (0,utilities_.insteadOf)(material_.SILENT);
    return __assign(__assign({}, computeNote(contourElement)), { intensity: {
            scalar: pitch === utilities_.as.number(material_.STANDARD_PITCH_INDEX_INDICATING_REST) ?
                silentScalar :
                utilities_.ONE_HALF,
        } });
};
var computePerimeterNote = function (contourElement) { return (__assign(__assign({}, computeNote(contourElement)), { envelope: {
        scalar: utilities_.use.Scalar(HOUNDSTOOTHTOPIA_THEME_ENVELOPE_SCALAR, utilities_.as.Scalar(utilities_.SQUARE_ROOT_OF_TWO)),
    } })); };


;// CONCATENATED MODULE: ./src/nominals.ts

var houndstoothtopiaThemeAs = (0,utilities_.computeNominalInterface)({
    number: {
        Grain: utilities_.DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE,
    },
    numericArray: {
        GrainCycleSequence: utilities_.DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE,
    },
}).as;


;// CONCATENATED MODULE: ./src/material/custom/coordinates/constants.ts
// tslint:disable no-magic-numbers

var TRANSLATION_TO_SPECIALIZE_COORDINATES_FOR_THEME = utilities_.DECREMENT;


;// CONCATENATED MODULE: ./src/material/custom/coordinates/houndstoothOutline/index.ts
var houndstoothOutline = [
    [-3, 1],
    [-1, -1],
    [0, -1],
    [1, -2],
    [1, -1],
    [2, -1],
    [1, 0],
    [1, 1],
    [-1, 3],
    [-1, 2],
    [0, 1],
    [-1, 1],
    [-1, 0],
    [-2, 1],
];
/* harmony default export */ const coordinates_houndstoothOutline = (houndstoothOutline);

;// CONCATENATED MODULE: ./src/material/custom/coordinates/coordinates.ts
var coordinates_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};



var thunkHoundstoothCoordinatesSpecializedForHoundstoothtopiaTheme = function () {
    return utilities_.use.Cardinal(utilities_.as.Cycle(coordinates_houndstoothOutline.map(function (_a) {
        var _b = coordinates_read(_a, 2), x = _b[0], y = _b[1];
        return [utilities_.as.Space(x), utilities_.as.Space(y)];
    })), TRANSLATION_TO_SPECIALIZE_COORDINATES_FOR_THEME);
};
var thunkHoundstoothSolidCenterOriginCoordinate = function () {
    return [utilities_.ORIGIN, utilities_.ORIGIN];
};


;// CONCATENATED MODULE: ./src/material/custom/coordinates/index.ts


;// CONCATENATED MODULE: ./src/material/custom/rhythms/perimeter.ts


var thunkPerimeterRhythm = function () {
    var houndstoothCoordinateCycle = utilities_.as.Cycle(thunkHoundstoothCoordinatesSpecializedForHoundstoothtopiaTheme());
    var houndstoothPerimeterSegmentLengths = (0,utilities_.map)(houndstoothCoordinateCycle, function (coordinate, index) {
        var nextIndex = utilities_.use.Cardinal(index, utilities_.INCREMENT);
        var nextCoordinate = utilities_.use.Ordinal(houndstoothCoordinateCycle, nextIndex);
        return (0,utilities_.distanceBetween)(coordinate, nextCoordinate);
    });
    return utilities_.as.Block(houndstoothPerimeterSegmentLengths.map(function (computeLength) {
        return utilities_.as.number(utilities_.use.Logarithm(computeLength, utilities_.as.Logarithm(utilities_.SQUARE_ROOT_OF_TWO)));
    }));
};


;// CONCATENATED MODULE: ./src/material/custom/rhythms/types.ts
var Stripe;
(function (Stripe) {
    Stripe["BLACK"] = "BLACK";
    Stripe["WHITE"] = "WHITE";
})(Stripe || (Stripe = {}));


;// CONCATENATED MODULE: ./src/material/custom/rhythms/supertile.ts


var thunkSupertileRhythm = function () {
    var supertile = [
        [Stripe.BLACK, Stripe.BLACK],
        [Stripe.WHITE, Stripe.BLACK],
        [Stripe.WHITE, Stripe.WHITE],
        [Stripe.BLACK, Stripe.WHITE],
    ];
    var durationIndicesForTile = supertile.map(function (tile) {
        var durationIndicesForStripes = (0,utilities_.map)(tile, function (stripe, index) {
            var count = stripe === Stripe.BLACK ? utilities_.ONCE : utilities_.TWICE;
            return (0,utilities_.repeat)([index], count);
        });
        return (0,utilities_.flatten)(durationIndicesForStripes);
    });
    return utilities_.as.Block((0,utilities_.flatten)(durationIndicesForTile)
        .map(function (durationIndexForTile) {
        return utilities_.as.number(durationIndexForTile);
    }));
};


;// CONCATENATED MODULE: ./src/material/custom/rhythms/index.ts



;// CONCATENATED MODULE: ./src/material/custom/constants.ts
// tslint:disable no-magic-numbers

var NO_TURN_COUNTERCLOCKWISE = utilities_.use.Scalar(utilities_.PI, utilities_.as.Scalar(0));
var EIGHTH_TURN_COUNTERCLOCKWISE = utilities_.use.Scalar(utilities_.PI, (0,utilities_.negative)(utilities_.ONE_FOURTH));
var QUARTER_TURN_COUNTERCLOCKWISE = utilities_.use.Scalar(utilities_.PI, (0,utilities_.negative)(utilities_.ONE_HALF));
var THREE_EIGHTHS_TURN_COUNTERCLOCKWISE = utilities_.use.Scalar(utilities_.PI, (0,utilities_.negative)(utilities_.THREE_FOURTHS));
var PERIMETER_PITCH_SPATIAL_SHIFT = utilities_.as.Cardinal(3);


;// CONCATENATED MODULE: ./src/material/custom/pitches/constants.ts
// tslint:disable no-magic-numbers

var TRANSLATION_TO_START_ON_ROOT_TIP_BEFORE_ROOT_BASE = utilities_.as.Cardinal((0,utilities_.negative)(7));


;// CONCATENATED MODULE: ./src/material/custom/pitches/perimeter.ts




var pitchesFromHeights = function (coordinates) {
    return coordinates.map(function (coordinate) {
        var height = coordinate[1];
        return utilities_.as.Scalar(utilities_.as.number(utilities_.use.Cardinal(height, PERIMETER_PITCH_SPATIAL_SHIFT)));
    });
};
var thunkPerimeterPitches = function () {
    var houndstoothCoordinates = thunkHoundstoothCoordinatesSpecializedForHoundstoothtopiaTheme();
    var cycledHoundstoothCoordinates = utilities_.use.Cardinal(houndstoothCoordinates, TRANSLATION_TO_START_ON_ROOT_TIP_BEFORE_ROOT_BASE);
    var houndstoothCenterCoordinate = thunkHoundstoothSolidCenterOriginCoordinate();
    var houndstoothTopRightGrainCoordinates = cycledHoundstoothCoordinates.map(function (coordinate) {
        return (0,utilities_.rotate)({
            coordinate: coordinate,
            fixedCoordinate: houndstoothCenterCoordinate,
            rotation: NO_TURN_COUNTERCLOCKWISE,
        });
    });
    var houndstoothTopGrainCoordinates = cycledHoundstoothCoordinates.map(function (coordinate) {
        return (0,utilities_.rotate)({
            coordinate: coordinate,
            fixedCoordinate: houndstoothCenterCoordinate,
            rotation: EIGHTH_TURN_COUNTERCLOCKWISE,
        });
    });
    var houndstoothTopLeftGrainCoordinates = cycledHoundstoothCoordinates.map(function (coordinate) {
        return (0,utilities_.rotate)({
            coordinate: coordinate,
            fixedCoordinate: houndstoothCenterCoordinate,
            rotation: QUARTER_TURN_COUNTERCLOCKWISE,
        });
    });
    var houndstoothLeftGrainCoordinates = cycledHoundstoothCoordinates.map(function (coordinate) {
        return (0,utilities_.rotate)({
            coordinate: coordinate,
            fixedCoordinate: houndstoothCenterCoordinate,
            rotation: THREE_EIGHTHS_TURN_COUNTERCLOCKWISE,
        });
    });
    var leftGrain = pitchesFromHeights(houndstoothLeftGrainCoordinates);
    var topGrain = pitchesFromHeights(houndstoothTopGrainCoordinates);
    var topLeftGrain = pitchesFromHeights(houndstoothTopLeftGrainCoordinates);
    var topRightGrain = pitchesFromHeights(houndstoothTopRightGrainCoordinates);
    return {
        leftGrain: leftGrain,
        topGrain: topGrain,
        topLeftGrain: topLeftGrain,
        topRightGrain: topRightGrain,
    };
};


;// CONCATENATED MODULE: ./src/material/custom/pitches/index.ts


;// CONCATENATED MODULE: ./src/material/custom/index.ts



;// CONCATENATED MODULE: ./src/material/pieces.ts
var pieces_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};




var thunkContourPieces = function () {
    var perimeterRhythm = thunkPerimeterRhythm();
    var supertileRhythm = thunkSupertileRhythm();
    var perimeterPitches = thunkPerimeterPitches();
    var perimeterPiece = function (pitches, position) {
        return utilities_.as.ContourPiece((0,utilities_.map)(perimeterRhythm, function (value, index) {
            return utilities_.as.ContourElement(__spreadArray([
                utilities_.as.number(utilities_.use.Ordinal(pitches, (0,utilities_.insteadOf)(index))),
                value
            ], pieces_read(position.map(utilities_.as.number)), false));
        }));
    };
    var perimeterLeftGrain = perimeterPiece(perimeterPitches.leftGrain, [utilities_.as.Space(0), utilities_.as.Space(1), utilities_.as.Space(0)]);
    var perimeterTopGrain = perimeterPiece(perimeterPitches.topGrain, [utilities_.as.Space(0), utilities_.as.Space(-1), utilities_.as.Space(0)]);
    var perimeterTopLeftGrain = perimeterPiece(perimeterPitches.topLeftGrain, [utilities_.as.Space(0), utilities_.as.Space(0), utilities_.as.Space(1)]);
    var perimeterTopRightGrain = perimeterPiece(perimeterPitches.topRightGrain, [utilities_.as.Space(0), utilities_.as.Space(0), utilities_.as.Space(-1)]);
    var supertileHigherPitch = utilities_.as.ContourPiece(supertileRhythm.map(function (value) {
        return utilities_.as.ContourElement([
            utilities_.as.number(HIGHER_SUPERTILE_PITCH), value, 1, 0, 0,
        ]);
    }));
    var supertileLowerPitch = utilities_.as.ContourPiece(supertileRhythm.map(function (value) {
        return utilities_.as.ContourElement([
            utilities_.as.number(LOWER_SUPERTILE_PITCH), value, -1, 0, 0,
        ]);
    }));
    var rawStandardPitchIndexIndicatingRest = utilities_.as.number(material_.STANDARD_PITCH_INDEX_INDICATING_REST);
    var perimeterRest = utilities_.as.ContourPiece(perimeterRhythm.map(function (value) {
        return utilities_.as.ContourElement([rawStandardPitchIndexIndicatingRest, value, 0, 0, 0]);
    }));
    var supertileRest = utilities_.as.ContourPiece(supertileRhythm.map(function (value) {
        return utilities_.as.ContourElement([rawStandardPitchIndexIndicatingRest, value, 0, 0, 0]);
    }));
    return {
        perimeterLeftGrain: perimeterLeftGrain,
        perimeterRest: perimeterRest,
        perimeterTopGrain: perimeterTopGrain,
        perimeterTopLeftGrain: perimeterTopLeftGrain,
        perimeterTopRightGrain: perimeterTopRightGrain,
        supertileHigherPitch: supertileHigherPitch,
        supertileLowerPitch: supertileLowerPitch,
        supertileRest: supertileRest,
    };
};


;// CONCATENATED MODULE: ./src/material/wholes.ts
var wholes_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var wholes_spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};




var thunkContourWholes = function () {
    var contourPieces = thunkContourPieces();
    var basicGrainCycle = utilities_.as.Cycle([0, 0, 1, 1].map(houndstoothtopiaThemeAs.Grain));
    var variedGrainCycle = utilities_.use.Cardinal(basicGrainCycle, utilities_.DECREMENT);
    var computeGrainCycleSequence = function (indexToVary) {
        var grainCycleSet = [basicGrainCycle, basicGrainCycle, basicGrainCycle, basicGrainCycle];
        (0,utilities_.arraySet)(grainCycleSet, indexToVary, variedGrainCycle);
        return houndstoothtopiaThemeAs.GrainCycleSequence((0,utilities_.flatten)(grainCycleSet));
    };
    var grainCycleSequenceToContourWhole = function (grainCycleSequence, contourPiece) {
        return utilities_.as.ContourWhole(utilities_.sequence.apply(void 0, wholes_spreadArray([], wholes_read(grainCycleSequence.map(function (grain) {
            return grain ? contourPiece : contourPieces.perimeterRest;
        })), false)));
    };
    var perimeterTopRightGrain = grainCycleSequenceToContourWhole(computeGrainCycleSequence(TOP_RIGHT_GRAIN_SEQUENCE_INDEX_TO_VARY), contourPieces.perimeterTopRightGrain);
    var perimeterTopGrain = grainCycleSequenceToContourWhole(computeGrainCycleSequence(TOP_GRAIN_SEQUENCE_INDEX_TO_VARY), contourPieces.perimeterTopGrain);
    var perimeterTopLeftGrain = grainCycleSequenceToContourWhole(computeGrainCycleSequence(TOP_LEFT_GRAIN_SEQUENCE_INDEX_TO_VARY), contourPieces.perimeterTopLeftGrain);
    var perimeterLeftGrain = grainCycleSequenceToContourWhole(computeGrainCycleSequence(LEFT_GRAIN_SEQUENCE_INDEX_TO_VARY), contourPieces.perimeterLeftGrain);
    return {
        perimeterLeftGrain: perimeterLeftGrain,
        perimeterTopGrain: perimeterTopGrain,
        perimeterTopLeftGrain: perimeterTopLeftGrain,
        perimeterTopRightGrain: perimeterTopRightGrain,
        supertileHigherPitch: utilities_.as.ContourWhole(contourPieces.supertileHigherPitch),
        supertileLowerPitch: utilities_.as.ContourWhole(contourPieces.supertileLowerPitch),
    };
};


;// CONCATENATED MODULE: ./src/material/notes.ts


var thunkNotes = function () {
    var contourWholes = thunkContourWholes();
    var supertileLowerPitch = contourWholes.supertileLowerPitch.map(computeSupertileNote);
    var supertileHigherPitch = contourWholes.supertileHigherPitch.map(computeSupertileNote);
    var perimeterTopRightGrain = contourWholes.perimeterTopRightGrain.map(computePerimeterNote);
    var perimeterTopGrain = contourWholes.perimeterTopGrain.map(computePerimeterNote);
    var perimeterTopLeftGrain = contourWholes.perimeterTopLeftGrain.map(computePerimeterNote);
    var perimeterLeftGrain = contourWholes.perimeterLeftGrain.map(computePerimeterNote);
    return {
        perimeterLeftGrain: perimeterLeftGrain,
        perimeterTopGrain: perimeterTopGrain,
        perimeterTopLeftGrain: perimeterTopLeftGrain,
        perimeterTopRightGrain: perimeterTopRightGrain,
        supertileHigherPitch: supertileHigherPitch,
        supertileLowerPitch: supertileLowerPitch,
    };
};


;// CONCATENATED MODULE: ./src/material/entities.ts


var materializeEntities = function () {
    var notes = thunkNotes();
    var supertileLowerPitch = {
        sections: [{ notes: notes.supertileLowerPitch }],
        timbreName: material_.TimbreNameEnum.BASS,
    };
    var supertileHigherPitch = {
        sections: [{ notes: notes.supertileHigherPitch }],
        timbreName: material_.TimbreNameEnum.DYNA_EP_BRIGHT,
    };
    var perimeterTopRightGrain = {
        sections: [{ notes: notes.perimeterTopRightGrain }],
        timbreName: material_.TimbreNameEnum.WARM_TRIANGLE,
    };
    var perimeterTopGrain = {
        sections: [{ notes: notes.perimeterTopGrain }],
        timbreName: material_.TimbreNameEnum.BRASS,
    };
    var perimeterTopLeftGrain = {
        sections: [{ notes: notes.perimeterTopLeftGrain }],
        timbreName: material_.TimbreNameEnum.PHONEME_OOH,
    };
    var perimeterLeftGrain = {
        sections: [{ notes: notes.perimeterLeftGrain }],
        timbreName: material_.TimbreNameEnum.TWELVE_OP_TINES,
    };
    return [
        supertileLowerPitch,
        supertileHigherPitch,
        perimeterTopRightGrain,
        perimeterTopGrain,
        perimeterTopLeftGrain,
        perimeterLeftGrain,
    ];
};


;// CONCATENATED MODULE: ./src/material/scalars.ts


var thunkRootOfTwoScalars = function () {
    var harmonicSeriesScale = (0,material_.computeHarmonicSeriesScale)();
    var harmonicSeriesScalars = harmonicSeriesScale.scalars || [];
    return harmonicSeriesScalars.map(function (harmonicSeriesScalar) {
        var negativeHarmonicSeriesValue = utilities_.as.number(utilities_.use.Cardinal(harmonicSeriesScalar, utilities_.DECREMENT));
        return utilities_.as.Scalar(utilities_.use.Power(utilities_.SQUARE_ROOT_OF_TWO, utilities_.as.Power(negativeHarmonicSeriesValue)));
    });
};


;// CONCATENATED MODULE: ./src/material/scales.ts


var materializeScales = function (specs) {
    return (0,material_.materializeStandardScales)(specs, { valueScalars: thunkRootOfTwoScalars() });
};


;// CONCATENATED MODULE: ./src/material/materials.ts


var material = {
    materializeEntities: materializeEntities,
    materializeScales: materializeScales,
};


;// CONCATENATED MODULE: ./src/material/index.ts


;// CONCATENATED MODULE: ./src/metadata/posts.ts
var env = "production";
// tslint:disable-next-line
var post = env !== 'test' && env != 'material' ? (__webpack_require__(377)["default"]) : '';


;// CONCATENATED MODULE: ./src/metadata/metadatas.ts

var metadata = {
    description: post,
    formattedName: 'Houndstoothtopia',
    mostRecentPublish: "2022-10-10T19:05:47.382Z" || 0,
    musicalIdeaIllustrated: 'irrational rhythm and harmony',
    originalPublish: '2018-02-21T07:00:00.000Z',
    version: "1.0.197" || 0,
};


;// CONCATENATED MODULE: ./src/metadata/index.ts


// EXTERNAL MODULE: external "@musical-patterns/spec"
var spec_ = __webpack_require__(918);
;// CONCATENATED MODULE: ./src/spec/constants.ts
// tslint:disable no-magic-numbers

var HOUNDSTOOTHTOPIA_THEME_INITIAL_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(141.42);
var HOUNDSTOOTHTOPIA_THEME_INITIAL_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(471.4);
var HOUNDSTOOTHTOPIA_THEME_INITIAL_METERS_PHYSICALIZATION = utilities_.musicalAs.Location(4);


;// CONCATENATED MODULE: ./src/spec/specs.ts
var specs_assign = (undefined && undefined.__assign) || function () {
    specs_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return specs_assign.apply(this, arguments);
};
var _a;


var initialSpecs = specs_assign(specs_assign({}, spec_.standardInitialSpecs), (_a = {}, _a[spec_.StandardSpec.MS_PHYSICALIZATION] = HOUNDSTOOTHTOPIA_THEME_INITIAL_MS_PHYSICALIZATION, _a[spec_.StandardSpec.HZ_PHYSICALIZATION] = HOUNDSTOOTHTOPIA_THEME_INITIAL_HZ_PHYSICALIZATION, _a[spec_.StandardSpec.METERS_PHYSICALIZATION] = HOUNDSTOOTHTOPIA_THEME_INITIAL_METERS_PHYSICALIZATION, _a));
var spec = {
    configurations: spec_.standardConfigurations,
    initialSpecs: initialSpecs,
};


;// CONCATENATED MODULE: ./src/spec/index.ts


;// CONCATENATED MODULE: ./src/patterns.ts
var patterns_a;




var pattern = {
    id: id_.Id.HOUNDSTOOTHTOPIA_THEME,
    material: material,
    metadata: metadata,
    spec: spec,
};
var patterns = (patterns_a = {},
    patterns_a[pattern.id] = pattern,
    patterns_a);


;// CONCATENATED MODULE: ./src/index.ts


})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});